/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1 "cmdline.opt"
/* This file is part of cfpeek  -*- c -*-
   Copyright (C) 2011 Sergey Poznyakoff

   Cfpeek is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Cfpeek is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with cfpeek.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifdef HAVE_GETOPT_H
# include <getopt.h>
#endif
#include <unistd.h>
#include "grecs/gitid.h"

static struct grecs_txtacc *pp_cmd_acc;
char *program_name;

#define PREPROC_NOT_SET 0
#define PREPROC_SET     1
#define PREPROC_DEFAULT 2
static int preproc_settings = PREPROC_NOT_SET;

#define CFPEEK_NODE_FLAG_DEFAULT \
	(GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE|GRECS_NODE_FLAG_DESCEND)

static int flags_on, flags_off;

struct format_flag {
	char *name;
	char *arg;
	char *descr;
	int flag;
	void (*handler)(const char *);
};

static void
set_parent_option(const char *str)
{
	parent_option = grecs_strdup(str);
}

static void
set_up_option(const char *str)
{
	up_option = atoi(str);
}

static void
set_delim_option(const char *str)
{
	flags_on |= *str & 0xff;
}

struct format_flag format_flag_table[] = {
	{ "parent", "NAME", "print the parent node with the given NAME",
	  0, set_parent_option },
	{ "up", "NUMBER", "ascend NUMBER of nodes",
	  0, set_up_option },
	{ "delim", "CHAR", "set path component delimiter",
	  0, set_delim_option },
	{ "locus", NULL, "print locations",
	  GRECS_NODE_FLAG_LOCUS },
	{ "path", NULL, "print paths",
	  GRECS_NODE_FLAG_PATH },
	{ "value", NULL, "print values",
	  GRECS_NODE_FLAG_VALUE },
	{ "quote", NULL, "always quote values",
	  GRECS_NODE_FLAG_QUOTE },
	{ "never-quote", NULL, "never quote values",
	  GRECS_NODE_FLAG_NOQUOTE },
	{ "quote-hex", NULL, "show unprintable characters as hex",
	  GRECS_NODE_FLAG_QUOTE_HEX },
	{ "descend", NULL, "descend into subnodes",
	  GRECS_NODE_FLAG_DESCEND },
	{ "default", NULL, "set default options",
	  CFPEEK_NODE_FLAG_DEFAULT },
	{ NULL }
};

static void
flags_help(FILE *stream)
{
	struct format_flag *fp;

	fprintf(stream, "[*] FLAGS is a comma-separated list of the following:\n");

	for (fp = format_flag_table; fp->name; fp++) {
		int n;
		fprintf(stream, "  ");
		if (fp->arg)
			n = fprintf(stream, "%s=%s", fp->name, fp->arg);
		else
			n = fprintf(stream, "[no]%s", fp->name);
		if (n < 24)
			n = 24 - n;
		else
			n = 2;
		fprintf(stream, "%*s%s\n", n, "", fp->descr);
	}
	fputc('\n', stream);
}

static const char *
cmpasgn(const char *a, const char *b)
{
	for (; *a && *b; a++, b++)  {
		if (*a != *b)
			return NULL;
	}
	if (*a == 0 && *b == '=')
		return b+1;

	return NULL;
}

static void
set_flag(const char *str)
{
	struct format_flag *fp;

	for (fp = format_flag_table; fp->name; fp++) {
		if (fp->arg) {
			const char *arg = cmpasgn(fp->name, str);
			if (arg) {
				fp->handler(arg);
				return;
			}
		} else if (strcmp(str, fp->name) == 0) {
			if (fp->handler)
				fp->handler(str);
			else
				flags_on |= fp->flag;
			return;
		} else if (strncmp(str, "no", 2) == 0 &&
			   strcmp(str + 2, fp->name) == 0) {
			if (fp->handler)
				fp->handler(str);
			else
				flags_off |= fp->flag;
			return;
		}
	}
	grecs_error(NULL, 0, "unknown option: %s", str);
}

#line 154 "cmdline.opt"

#line 154
void print_help(void);
#line 154
void print_usage(void);
#line 329 "cmdline.opt"

#line 329
#include <grecs.h>
#line 329
/* Option codes */
#line 329
enum {
#line 329
	_OPTION_INIT=255,
#line 329
	#line 329 "cmdline.opt"

#line 329
	OPTION_USAGE,

#line 329 "cmdline.opt"
	MAX_OPTION
#line 329
};
#line 329
#ifdef HAVE_GETOPT_LONG
#line 329
static struct option long_options[] = {
#line 329
	#line 163 "cmdline.opt"

#line 163
	{ "format", required_argument, 0, 'H' },
#line 179 "cmdline.opt"

#line 179
	{ "quiet", no_argument, 0, 'q' },
#line 187 "cmdline.opt"

#line 187
	{ "parser", required_argument, 0, 'p' },
#line 208 "cmdline.opt"

#line 208
	{ "literal", no_argument, 0, 'L' },
#line 214 "cmdline.opt"

#line 214
	{ "reduce", no_argument, 0, 'r' },
#line 220 "cmdline.opt"

#line 220
	{ "sort", no_argument, 0, 'S' },
#line 226 "cmdline.opt"

#line 226
	{ "matches", required_argument, 0, 'm' },
#line 232 "cmdline.opt"

#line 232
	{ "set", required_argument, 0, 's' },
#line 255 "cmdline.opt"

#line 255
	{ "lang", required_argument, 0, 'l' },
#line 261 "cmdline.opt"

#line 261
	{ "file", required_argument, 0, 'f' },
#line 267 "cmdline.opt"

#line 267
	{ "expression", required_argument, 0, 'e' },
#line 275 "cmdline.opt"

#line 275
	{ "include-directory", required_argument, 0, 'I' },
#line 283 "cmdline.opt"

#line 283
	{ "define", required_argument, 0, 'D' },
#line 301 "cmdline.opt"

#line 301
	{ "preprocessor", required_argument, 0, 'P' },
#line 308 "cmdline.opt"

#line 308
	{ "no-preprocessor", no_argument, 0, 'N' },
#line 317 "cmdline.opt"

#line 317
	{ "debug-parser", no_argument, 0, 'x' },
#line 323 "cmdline.opt"

#line 323
	{ "debug-lexer", no_argument, 0, 'X' },
#line 329 "cmdline.opt"

#line 329
	{ "help", no_argument, 0, 'h' },
#line 329 "cmdline.opt"

#line 329
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 329 "cmdline.opt"

#line 329
	{ "version", no_argument, 0, 'V' },

#line 329 "cmdline.opt"
	{0, 0, 0, 0}
#line 329
};
#line 329
#endif
#line 329
static struct opthelp {
#line 329
	const char *opt;
#line 329
	const char *arg;
#line 329
	int is_optional;
#line 329
	const char *descr;
#line 329
} opthelp[] = {
#line 329
	#line 161 "cmdline.opt"

#line 161
	{ NULL, NULL, 0, N_("Output control") },
#line 165 "cmdline.opt"

#line 165
	{
#line 165
#ifdef HAVE_GETOPT_LONG
#line 165
	  "-H, --format",
#line 165
#else
#line 165
	  "-H",
#line 165
#endif
#line 165
				   N_("FLAGS"), 0, N_("set output format flags [*]") },
#line 181 "cmdline.opt"

#line 181
	{
#line 181
#ifdef HAVE_GETOPT_LONG
#line 181
	  "-q, --quiet",
#line 181
#else
#line 181
	  "-q",
#line 181
#endif
#line 181
				   NULL, 0, N_("suppress error diagnostics") },
#line 185 "cmdline.opt"

#line 185
	{ NULL, NULL, 0, N_("Modifiers") },
#line 189 "cmdline.opt"

#line 189
	{
#line 189
#ifdef HAVE_GETOPT_LONG
#line 189
	  "-p, --parser",
#line 189
#else
#line 189
	  "-p",
#line 189
#endif
#line 189
				   N_("GRECS|META1|BIND|GIT|PATH"), 0, N_("set parser type") },
#line 210 "cmdline.opt"

#line 210
	{
#line 210
#ifdef HAVE_GETOPT_LONG
#line 210
	  "-L, --literal",
#line 210
#else
#line 210
	  "-L",
#line 210
#endif
#line 210
				   NULL, 0, N_("use literal matching") },
#line 216 "cmdline.opt"

#line 216
	{
#line 216
#ifdef HAVE_GETOPT_LONG
#line 216
	  "-r, --reduce",
#line 216
#else
#line 216
	  "-r",
#line 216
#endif
#line 216
				   NULL, 0, N_("reduce the tree") },
#line 222 "cmdline.opt"

#line 222
	{
#line 222
#ifdef HAVE_GETOPT_LONG
#line 222
	  "-S, --sort",
#line 222
#else
#line 222
	  "-S",
#line 222
#endif
#line 222
				   NULL, 0, N_("sort parse tree lexicografically") },
#line 228 "cmdline.opt"

#line 228
	{
#line 228
#ifdef HAVE_GETOPT_LONG
#line 228
	  "-m, --matches",
#line 228
#else
#line 228
	  "-m",
#line 228
#endif
#line 228
				   N_("NUMBER"), 0, N_("output at most NUMBER matches") },
#line 234 "cmdline.opt"

#line 234
	{
#line 234
#ifdef HAVE_GETOPT_LONG
#line 234
	  "-s, --set",
#line 234
#else
#line 234
	  "-s",
#line 234
#endif
#line 234
				   N_("PATH=VAL"), 0, N_("set a keyword") },
#line 253 "cmdline.opt"

#line 253
	{ NULL, NULL, 0, N_("Scripting") },
#line 257 "cmdline.opt"

#line 257
	{
#line 257
#ifdef HAVE_GETOPT_LONG
#line 257
	  "-l, --lang",
#line 257
#else
#line 257
	  "-l",
#line 257
#endif
#line 257
				   N_("NAME"), 0, N_("select scripting language to use") },
#line 263 "cmdline.opt"

#line 263
	{
#line 263
#ifdef HAVE_GETOPT_LONG
#line 263
	  "-f, --file",
#line 263
#else
#line 263
	  "-f",
#line 263
#endif
#line 263
				   N_("FILE"), 0, N_("apply this script FILE to each node found") },
#line 269 "cmdline.opt"

#line 269
	{
#line 269
#ifdef HAVE_GETOPT_LONG
#line 269
	  "-e, --expression",
#line 269
#else
#line 269
	  "-e",
#line 269
#endif
#line 269
				   N_("EXPR"), 0, N_("apply this expression to each node found") },
#line 273 "cmdline.opt"

#line 273
	{ NULL, NULL, 0, N_("Preprocessor control") },
#line 277 "cmdline.opt"

#line 277
	{
#line 277
#ifdef HAVE_GETOPT_LONG
#line 277
	  "-I, --include-directory",
#line 277
#else
#line 277
	  "-I",
#line 277
#endif
#line 277
				   N_("DIR"), 0, N_("add include directory") },
#line 285 "cmdline.opt"

#line 285
	{
#line 285
#ifdef HAVE_GETOPT_LONG
#line 285
	  "-D, --define",
#line 285
#else
#line 285
	  "-D",
#line 285
#endif
#line 285
				   N_("SYMBOL[=VALUE]"), 0, N_("define a preprocessor symbol") },
#line 303 "cmdline.opt"

#line 303
	{
#line 303
#ifdef HAVE_GETOPT_LONG
#line 303
	  "-P, --preprocessor",
#line 303
#else
#line 303
	  "-P",
#line 303
#endif
#line 303
				   N_("COMMAND"), 0, N_("use COMMAND instead of the default preprocessor") },
#line 310 "cmdline.opt"

#line 310
	{
#line 310
#ifdef HAVE_GETOPT_LONG
#line 310
	  "-N, --no-preprocessor",
#line 310
#else
#line 310
	  "-N",
#line 310
#endif
#line 310
				   NULL, 0, N_("disable preprocessing") },
#line 315 "cmdline.opt"

#line 315
	{ NULL, NULL, 0, N_("Debugging") },
#line 319 "cmdline.opt"

#line 319
	{
#line 319
#ifdef HAVE_GETOPT_LONG
#line 319
	  "-x, --debug-parser",
#line 319
#else
#line 319
	  "-x",
#line 319
#endif
#line 319
				   NULL, 0, N_("debug configuration file parser") },
#line 325 "cmdline.opt"

#line 325
	{
#line 325
#ifdef HAVE_GETOPT_LONG
#line 325
	  "-X, --debug-lexer",
#line 325
#else
#line 325
	  "-X",
#line 325
#endif
#line 325
				   NULL, 0, N_("debug configuration file lexer") },
#line 329 "cmdline.opt"

#line 329
	{ NULL, NULL, 0, N_("Other options") },
#line 329 "cmdline.opt"

#line 329
	{
#line 329
#ifdef HAVE_GETOPT_LONG
#line 329
	  "-h, --help",
#line 329
#else
#line 329
	  "-h",
#line 329
#endif
#line 329
				   NULL, 0, N_("Give this help list") },
#line 329 "cmdline.opt"

#line 329
	{
#line 329
#ifdef HAVE_GETOPT_LONG
#line 329
	  "--usage",
#line 329
#else
#line 329
	  "",
#line 329
#endif
#line 329
				   NULL, 0, N_("Give a short usage message") },
#line 329 "cmdline.opt"

#line 329
	{
#line 329
#ifdef HAVE_GETOPT_LONG
#line 329
	  "-V, --version",
#line 329
#else
#line 329
	  "-V",
#line 329
#endif
#line 329
				   NULL, 0, N_("Print program version") },

#line 329 "cmdline.opt"
};
#line 154 "cmdline.opt"

#line 154
const char *program_version = "cfpeek" " (" PACKAGE_NAME ") " PACKAGE_VERSION;
#line 154
static char doc[] = N_("Get variables from a configuration file");
#line 154
static char args_doc[] = N_("FILE [PATH...]");
#line 154
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 154
struct grecs_node *cmdline_tree;
#line 154

#line 154
#define DESCRCOLUMN 30
#line 154
#define RMARGIN 79
#line 154
#define GROUPCOLUMN 2
#line 154
#define USAGECOLUMN 13
#line 154

#line 154
static void
#line 154
indent (size_t start, size_t col)
#line 154
{
#line 154
  for (; start < col; start++)
#line 154
    putchar (' ');
#line 154
}
#line 154

#line 154
static void
#line 154
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 154
{
#line 154
  while (*descr)
#line 154
    {
#line 154
      size_t s = 0;
#line 154
      size_t i;
#line 154
      size_t width = rmargin - lmargin;
#line 154

#line 154
      for (i = 0; ; i++)
#line 154
	{
#line 154
	  if (descr[i] == 0 || descr[i] == ' ' || descr[i] == '\t')
#line 154
	    {
#line 154
	      if (i > width)
#line 154
		break;
#line 154
	      s = i;
#line 154
	      if (descr[i] == 0)
#line 154
		break;
#line 154
	    }
#line 154
	}
#line 154
      printf ("%*.*s\n", s, s, descr);
#line 154
      descr += s;
#line 154
      if (*descr)
#line 154
	{
#line 154
	  indent (0, lmargin);
#line 154
	  descr++;
#line 154
	}
#line 154
    }
#line 154
}
#line 154

#line 154
#define NOPTHELP (sizeof (opthelp) / sizeof (opthelp[0]))
#line 154

#line 154
static int
#line 154
optcmp (const void *a, const void *b)
#line 154
{
#line 154
  struct opthelp const *ap = (struct opthelp const *)a;
#line 154
  struct opthelp const *bp = (struct opthelp const *)b;
#line 154
  const char *opta, *optb;
#line 154
  size_t alen, blen;
#line 154

#line 154
  for (opta = ap->opt; *opta == '-'; opta++)
#line 154
    ;
#line 154
  alen = strcspn (opta, ",");
#line 154
  
#line 154
  for (optb = bp->opt; *optb == '-'; optb++)
#line 154
    ;
#line 154
  blen = strcspn (optb, ",");
#line 154

#line 154
  if (alen > blen)
#line 154
    blen = alen;
#line 154
  
#line 154
  return strncmp (opta, optb, blen);
#line 154
}
#line 154

#line 154
static void
#line 154
sort_options (int start, int count)
#line 154
{
#line 154
  qsort (opthelp + start, count, sizeof (opthelp[0]), optcmp);
#line 154
}
#line 154

#line 154
static int
#line 154
sort_group (int start)
#line 154
{
#line 154
  int i;
#line 154
  
#line 154
  for (i = start; i < NOPTHELP && opthelp[i].opt; i++)
#line 154
    ;
#line 154
  sort_options (start, i - start);
#line 154
  return i + 1;
#line 154
}
#line 154

#line 154
static void
#line 154
sort_opthelp (void)
#line 154
{
#line 154
  int start;
#line 154

#line 154
  for (start = 0; start < NOPTHELP; )
#line 154
    {
#line 154
      if (!opthelp[start].opt)
#line 154
	start = sort_group (start + 1);
#line 154
      else 
#line 154
	start = sort_group (start);
#line 154
    }
#line 154
}
#line 154

#line 154
void (*print_help_hook) (FILE *stream);
#line 154

#line 154
void
#line 154
print_help (void)
#line 154
{
#line 154
  unsigned i;
#line 154
  int argsused = 0;
#line 154

#line 154
  printf ("%s %s [%s]... %s\n", _("Usage:"), "cfpeek", _("OPTION"),
#line 154
	  gettext (args_doc));
#line 154
  if (doc[0])
#line 154
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 154
  putchar ('\n');
#line 154

#line 154
  sort_opthelp ();
#line 154
  for (i = 0; i < NOPTHELP; i++)
#line 154
    {
#line 154
      unsigned n;
#line 154
      if (opthelp[i].opt)
#line 154
	{
#line 154
	  n = printf ("  %s", opthelp[i].opt);
#line 154
	  if (opthelp[i].arg)
#line 154
	    {
#line 154
	      char *cb, *ce;
#line 154
	      argsused = 1;
#line 154
	      if (strlen (opthelp[i].opt) == 2)
#line 154
		{
#line 154
		  if (!opthelp[i].is_optional)
#line 154
		    {
#line 154
		      putchar (' ');
#line 154
		      n++;
#line 154
		    }
#line 154
		}
#line 154
	      else
#line 154
		{
#line 154
		  putchar ('=');
#line 154
		  n++;
#line 154
		}
#line 154
	      if (opthelp[i].is_optional)
#line 154
		{
#line 154
		  cb = "[";
#line 154
		  ce = "]";
#line 154
		}
#line 154
	      else
#line 154
		cb = ce = "";
#line 154
	      n += printf ("%s%s%s", cb, gettext (opthelp[i].arg), ce);
#line 154
	    }
#line 154
	  if (n >= DESCRCOLUMN)
#line 154
	    {
#line 154
	      putchar ('\n');
#line 154
	      n = 0;
#line 154
	    }
#line 154
	  indent (n, DESCRCOLUMN);
#line 154
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 154
	}
#line 154
      else
#line 154
	{
#line 154
	  if (i)
#line 154
	    putchar ('\n');
#line 154
	  indent (0, GROUPCOLUMN);
#line 154
	  print_option_descr (gettext (opthelp[i].descr),
#line 154
			      GROUPCOLUMN, RMARGIN);
#line 154
	  putchar ('\n');
#line 154
	}
#line 154
    }
#line 154

#line 154
  putchar ('\n');
#line 154
  if (argsused)
#line 154
    {
#line 154
      print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 154
      putchar ('\n');
#line 154
    }
#line 154
 
#line 154
  if (print_help_hook)
#line 154
    print_help_hook (stdout);
#line 154
    
#line 154
 /* TRANSLATORS: The placeholder indicates the bug-reporting address
    for this package.  Please add _another line_ saying
    "Report translation bugs to <...>\n" with the address for translation
    bugs (typically your translation team's web or email address).  */
#line 154
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 154
  
#line 154
#ifdef PACKAGE_URL
#line 154
  printf (_("%s home page: <%s>\n"), PACKAGE_NAME, PACKAGE_URL);
#line 154
#endif
#line 154
}
#line 154

#line 154
static int
#line 154
cmpidx_short (const void *a, const void *b)
#line 154
{
#line 154
  unsigned const *ai = (unsigned const *)a;
#line 154
  unsigned const *bi = (unsigned const *)b;
#line 154

#line 154
  return opthelp[*ai].opt[1] - opthelp[*bi].opt[1];
#line 154
}
#line 154
  
#line 154
#ifdef HAVE_GETOPT_LONG
#line 154
static int
#line 154
cmpidx_long (const void *a, const void *b)
#line 154
{
#line 154
  unsigned const *ai = (unsigned const *)a;
#line 154
  unsigned const *bi = (unsigned const *)b;
#line 154
  struct opthelp const *ap = opthelp + *ai;
#line 154
  struct opthelp const *bp = opthelp + *bi;
#line 154
  char const *opta, *optb;
#line 154
  size_t lena, lenb;
#line 154

#line 154
  if (ap->opt[1] == '-')
#line 154
    opta = ap->opt;
#line 154
  else
#line 154
    opta = ap->opt + 4;
#line 154
  lena = strcspn (opta, ",");
#line 154
  
#line 154
  if (bp->opt[1] == '-')
#line 154
    optb = bp->opt;
#line 154
  else
#line 154
    optb = bp->opt + 4;
#line 154
  lenb = strcspn (optb, ",");
#line 154
  return strncmp (opta, optb, lena > lenb ? lenb : lena);
#line 154
}
#line 154
#endif
#line 154

#line 154
void
#line 154
print_usage (void)
#line 154
{
#line 154
  unsigned i;
#line 154
  unsigned n;
#line 154
  char buf[RMARGIN+1];
#line 154
  unsigned *idxbuf;
#line 154
  unsigned nidx;
#line 154
  
#line 154
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 154
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 154

#line 154
  idxbuf = calloc (NOPTHELP, sizeof (idxbuf[0]));
#line 154
  if (!idxbuf)
#line 154
    {
#line 154
      fprintf (stderr, "not enough memory");
#line 154
      abort ();
#line 154
    }
#line 154

#line 154
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "cfpeek");
#line 154

#line 154
  /* Print a list of short options without arguments. */
#line 154
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 154
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 154
	  && opthelp[i].arg == NULL)
#line 154
	idxbuf[nidx++] = i;
#line 154

#line 154
  if (nidx)
#line 154
    {
#line 154
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_short);
#line 154

#line 154
      ADDC ('[');
#line 154
      ADDC ('-');
#line 154
      for (i = 0; i < nidx; i++)
#line 154
	{
#line 154
	  ADDC (opthelp[idxbuf[i]].opt[1]);
#line 154
	}
#line 154
      ADDC (']');
#line 154
    }
#line 154

#line 154
  /* Print a list of short options with arguments. */
#line 154
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 154
    {
#line 154
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 154
	  && opthelp[i].arg)
#line 154
	idxbuf[nidx++] = i;
#line 154
    }
#line 154

#line 154
  if (nidx)
#line 154
    {
#line 154
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_short);
#line 154
    
#line 154
      for (i = 0; i < nidx; i++)
#line 154
	{
#line 154
	  struct opthelp *opt = opthelp + idxbuf[i];
#line 154
	  size_t len = 5 + strlen (opt->arg)
#line 154
	                 + (opt->is_optional ? 2 : 1);
#line 154
      
#line 154
	  if (n + len > RMARGIN) FLUSH;
#line 154
	  buf[n++] = ' ';
#line 154
	  buf[n++] = '[';
#line 154
	  buf[n++] = '-';
#line 154
	  buf[n++] = opt->opt[1];
#line 154
	  if (opt->is_optional)
#line 154
	    {
#line 154
	      buf[n++] = '[';
#line 154
	      strcpy (&buf[n], opt->arg);
#line 154
	      n += strlen (opt->arg);
#line 154
	      buf[n++] = ']';
#line 154
	    }
#line 154
	  else
#line 154
	    {
#line 154
	      buf[n++] = ' ';
#line 154
	      strcpy (&buf[n], opt->arg);
#line 154
	      n += strlen (opt->arg);
#line 154
	    }
#line 154
	  buf[n++] = ']';
#line 154
	}
#line 154
    }
#line 154
  
#line 154
#ifdef HAVE_GETOPT_LONG
#line 154
  /* Print a list of long options */
#line 154
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 154
    {
#line 154
      if (opthelp[i].opt && opthelp[i].descr
#line 154
	  &&  (opthelp[i].opt[1] == '-' || opthelp[i].opt[2] == ','))
#line 154
	idxbuf[nidx++] = i;
#line 154
    }
#line 154

#line 154
  if (nidx)
#line 154
    {
#line 154
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_long);
#line 154
	
#line 154
      for (i = 0; i < nidx; i++)
#line 154
	{
#line 154
	  struct opthelp *opt = opthelp + idxbuf[i];
#line 154
	  size_t len;
#line 154
	  const char *longopt;
#line 154
	  
#line 154
	  if (opt->opt[1] == '-')
#line 154
	    longopt = opt->opt;
#line 154
	  else if (opt->opt[2] == ',')
#line 154
	    longopt = opt->opt + 4;
#line 154
	  else
#line 154
	    continue;
#line 154

#line 154
	  len = 3 + strlen (longopt)
#line 154
	          + (opt->arg ? 1 + strlen (opt->arg)
#line 154
		  + (opt->is_optional ? 2 : 0) : 0);
#line 154
	  if (n + len > RMARGIN) FLUSH;
#line 154
	  buf[n++] = ' ';
#line 154
	  buf[n++] = '[';
#line 154
	  strcpy (&buf[n], longopt);
#line 154
	  n += strlen (longopt);
#line 154
	  if (opt->arg)
#line 154
	    {
#line 154
	      buf[n++] = '=';
#line 154
	      if (opt->is_optional)
#line 154
		{
#line 154
		  buf[n++] = '[';
#line 154
		  strcpy (&buf[n], opt->arg);
#line 154
		  n += strlen (opt->arg);
#line 154
		  buf[n++] = ']';
#line 154
		}
#line 154
	      else
#line 154
		{
#line 154
		  strcpy (&buf[n], opt->arg);
#line 154
		  n += strlen (opt->arg);
#line 154
		}
#line 154
	    }
#line 154
	  buf[n++] = ']';
#line 154
	}
#line 154
    }
#line 154
#endif
#line 154
  FLUSH;
#line 154
  free (idxbuf);
#line 154
}
#line 154

#line 154
const char version_etc_copyright[] =
#line 154
  /* Do *not* mark this string for translation.  First %s is a copyright
     symbol suitable for this locale, and second %s are the copyright
     years.  */
#line 154
  "Copyright %s %s %s";
#line 154

#line 154
void
#line 154
print_version_only(const char *program_version, FILE *stream)
#line 154
{
#line 154
  fprintf (stream, "%s\n", program_version);
#line 154
  /* TRANSLATORS: Translate "(C)" to the copyright symbol
     (C-in-a-circle), if this symbol is available in the user's
     locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 154
  fprintf (stream, version_etc_copyright, _("(C)"),
#line 154
	   "2011",
#line 154
	   "Sergey Poznyakoff");
#line 154
  fputc ('\n', stream);
#line 154
}
#line 154

#line 154

#line 154

#line 154
void (*print_version_hook)(FILE *stream);
#line 154

#line 154
void
#line 154
print_version(const char *program_version, FILE *stream)
#line 154
{
#line 154
  
#line 154
  print_version_only(program_version, stream);
#line 154

#line 154
  fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 154
	 stream);
#line 154
  if (print_version_hook)
#line 154
    print_version_hook (stream);
#line 154
		
#line 154
}
#line 154

#line 329 "cmdline.opt"

#line 329


void
cfpeek_version_hook(FILE *stream)
{
	fprintf(stream, "compiled with:\n");
	fprintf(stream, "  Grecs %s\n", GRECS_GIT_ID);
#ifdef GUILE_VERSION
	fprintf(stream, "  Guile %s\n", GUILE_VERSION);
#endif
}


void
parse_options(int argc, char *argv[])
{
	program_name = strrchr(argv[0], '/');
	if (program_name)
		program_name++;
	else
		program_name = argv[0];
	print_help_hook = flags_help;
	print_version_hook = cfpeek_version_hook;
        
#line 352
 {
#line 352
  int c;
#line 352

#line 352
#ifdef HAVE_GETOPT_LONG
#line 352
  while ((c = getopt_long(argc, argv, "H:qp:LrSm:s:l:f:e:I:D:P:NxXhV",
#line 352
			  long_options, NULL)) != EOF)
#line 352
#else
#line 352
  while ((c = getopt(argc, argv, "H:qp:LrSm:s:l:f:e:I:D:P:NxXhV")) != EOF)
#line 352
#endif
#line 352
    {
#line 352
      switch (c)
#line 352
	{
#line 352
	default:
#line 352
	   exit(EX_USAGE);	   exit(EX_USAGE);
#line 352
	#line 165 "cmdline.opt"
	 case 'H':
#line 165
	  {
#line 165

        int i;
        struct wordsplit ws;
	ws.ws_delim = ",";
	if (wordsplit(optarg, &ws,
		      WRDSF_DELIM|WRDSF_SQUEEZE_DELIMS|
		      WRDSF_NOVAR|WRDSF_NOCMD|WRDSF_SHOWERR))
		exit(EX_SOFTWARE);
	for (i = 0; i < ws.ws_wordc; i++) {
		set_flag(ws.ws_wordv[i]);
	}
	wordsplit_free(&ws);

#line 177
	     break;
#line 177
	  }
#line 181 "cmdline.opt"
	 case 'q':
#line 181
	  {
#line 181

	quiet_option++;

#line 183
	     break;
#line 183
	  }
#line 189 "cmdline.opt"
	 case 'p':
#line 189
	  {
#line 189

	if (strcasecmp(optarg, "GRECS") == 0) {
		grecs_parser_fun = grecs_grecs_parser;
		if (preproc_settings == PREPROC_NOT_SET)
			preproc_settings = PREPROC_DEFAULT;
	} else if (strcasecmp(optarg, "META1") == 0)
		grecs_parser_fun = grecs_meta1_parser;
	else if (strcasecmp(optarg, "BIND") == 0)
		grecs_parser_fun = grecs_bind_parser;
	else if (strcasecmp(optarg, "GIT") == 0)
		grecs_parser_fun = grecs_git_parser;
	else if (strcasecmp(optarg, "PATH") == 0)
		grecs_parser_fun = grecs_path_parser;
	else {
		grecs_error(NULL, 0, "unsupported parser type");
		exit(EX_USAGE);
	}

#line 206
	     break;
#line 206
	  }
#line 210 "cmdline.opt"
	 case 'L':
#line 210
	  {
#line 210

	mode = MODE_LITERAL;

#line 212
	     break;
#line 212
	  }
#line 216 "cmdline.opt"
	 case 'r':
#line 216
	  {
#line 216

	reduce_option = 1;

#line 218
	     break;
#line 218
	  }
#line 222 "cmdline.opt"
	 case 'S':
#line 222
	  {
#line 222

       sort_option = 1;

#line 224
	     break;
#line 224
	  }
#line 228 "cmdline.opt"
	 case 'm':
#line 228
	  {
#line 228

	max_matches = atoi(optarg);

#line 230
	     break;
#line 230
	  }
#line 234 "cmdline.opt"
	 case 's':
#line 234
	  {
#line 234

        struct wordsplit ws;

	ws.ws_delim = "=";
	if (wordsplit(optarg, &ws, WRDSF_NOVAR | WRDSF_NOCMD |
                                   WRDSF_QUOTE | WRDSF_CESCAPES	|
				   WRDSF_DELIM)) {
	     grecs_error(NULL, 0, "cannot split string: %s",
	                 wordsplit_strerror(&ws));
	     exit(EX_SOFTWARE);
	}
        if (ws.ws_wordc != 2) {
                grecs_error(NULL, 0, "set: invalid syntax");
		exit(EX_USAGE);
	}
	do {
#line 249
   struct grecs_node *node = grecs_node_from_path(ws.ws_wordv[0], ws.ws_wordv[1]);
#line 249
   if (!cmdline_tree)
#line 249
	cmdline_tree = node;
#line 249
   else
#line 249
	grecs_node_bind(cmdline_tree, node, 0);
#line 249
} while(0)
#line 249
;
        wordsplit_free(&ws);

#line 251
	     break;
#line 251
	  }
#line 257 "cmdline.opt"
	 case 'l':
#line 257
	  {
#line 257

	script_select(optarg);

#line 259
	     break;
#line 259
	  }
#line 263 "cmdline.opt"
	 case 'f':
#line 263
	  {
#line 263

	script_file = optarg;

#line 265
	     break;
#line 265
	  }
#line 269 "cmdline.opt"
	 case 'e':
#line 269
	  {
#line 269

	script_expr = optarg;

#line 271
	     break;
#line 271
	  }
#line 277 "cmdline.opt"
	 case 'I':
#line 277
	  {
#line 277

        if (preproc_settings == PREPROC_NOT_SET)
		preproc_settings = PREPROC_DEFAULT;
	grecs_preproc_add_include_dir(optarg);

#line 281
	     break;
#line 281
	  }
#line 285 "cmdline.opt"
	 case 'D':
#line 285
	  {
#line 285

        char *p;

        if (preproc_settings == PREPROC_NOT_SET)
		preproc_settings = PREPROC_DEFAULT;
        if (!pp_cmd_acc)
		pp_cmd_acc = grecs_txtacc_create();
        grecs_txtacc_grow(pp_cmd_acc, " \"-D", 4);
        for (p = optarg; *p; p++) {
		if (*p == '\\' || *p == '"')
			grecs_txtacc_grow_char(pp_cmd_acc, '\\');
		grecs_txtacc_grow_char(pp_cmd_acc, *p);
	}
	grecs_txtacc_grow_char(pp_cmd_acc, '"');			

#line 299
	     break;
#line 299
	  }
#line 303 "cmdline.opt"
	 case 'P':
#line 303
	  {
#line 303

	grecs_preprocessor = optarg;
        preproc_settings = PREPROC_SET;

#line 306
	     break;
#line 306
	  }
#line 310 "cmdline.opt"
	 case 'N':
#line 310
	  {
#line 310

	grecs_preprocessor = NULL;
        preproc_settings = PREPROC_SET;

#line 313
	     break;
#line 313
	  }
#line 319 "cmdline.opt"
	 case 'x':
#line 319
	  {
#line 319

	grecs_gram_trace(1);

#line 321
	     break;
#line 321
	  }
#line 325 "cmdline.opt"
	 case 'X':
#line 325
	  {
#line 325

	grecs_lex_trace(1);

#line 327
	     break;
#line 327
	  }
#line 329 "cmdline.opt"
	 case 'h':
#line 329
	  {
#line 329

#line 329
		print_help ();
#line 329
		exit (0);
#line 329
	 
#line 329
	     break;
#line 329
	  }
#line 329 "cmdline.opt"
	 case OPTION_USAGE:
#line 329
	  {
#line 329

#line 329
		print_usage ();
#line 329
		exit (0);
#line 329
	 
#line 329
	     break;
#line 329
	  }
#line 329 "cmdline.opt"
	 case 'V':
#line 329
	  {
#line 329

#line 329
		/* Give version */
#line 329
		print_version(program_version, stdout);
#line 329
		exit (0);
#line 329
	 
#line 329
	     break;
#line 329
	  }

#line 352 "cmdline.opt"
	}
#line 352
    }
#line 352
  file_index = optind;
#line 352
  if (cmdline_tree)
#line 352
    {
#line 352
      struct grecs_node *rn = grecs_node_create(grecs_node_root, NULL);
#line 352
      rn->down = cmdline_tree;
#line 352
      cmdline_tree = rn;
#line 352
    }
#line 352
 }
#line 352

	if (!(flags_on & _GRECS_NODE_MASK_OUTPUT)) 
		flags_on |= GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE;
	flags = flags_on & ~flags_off;
	if (!(flags & (GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE))) {
		grecs_warning(NULL, 0, "assuming --format=path,value");
		flags |= GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE;
	}
	if (preproc_settings == PREPROC_DEFAULT)
		grecs_preprocessor = DEFAULT_PREPROCESSOR;
	if (pp_cmd_acc && grecs_preprocessor) {
		char *args, *cmd;

		grecs_txtacc_grow_char(pp_cmd_acc, 0);
		args = grecs_txtacc_finish(pp_cmd_acc, 0);
		cmd = grecs_malloc(strlen(grecs_preprocessor) +
				   strlen(args) + 1);
		strcpy(cmd, grecs_preprocessor);
		strcat(cmd, args);
		grecs_preprocessor = cmd;
	}
	grecs_txtacc_free(pp_cmd_acc);

	script_init();
}
